﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace combodropdown
{
    public partial class Form1 : Form
    {
        System.Collections.ArrayList newlist, list;
        string selecteditem;
        
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            FarPoint.Win.Spread.CellType.ComboBoxCellType cmbocell = new FarPoint.Win.Spread.CellType.ComboBoxCellType();
            cmbocell.Items = (new String[] { "January", "February", "March", "April", "May", "June" });
            fpSpread1.ActiveSheet.Columns[0].CellType = cmbocell;
            newlist = new System.Collections.ArrayList();
            fpSpread1.ComboSelChange += new FarPoint.Win.Spread.EditorNotifyEventHandler(fpSpread1_ComboSelChange);
            fpSpread1.ComboDropDown += new FarPoint.Win.Spread.EditorNotifyEventHandler(fpSpread1_ComboDropDown);

        }
        void fpSpread1_ComboDropDown(object sender, FarPoint.Win.Spread.EditorNotifyEventArgs e)
        {
            FarPoint.Win.FpCombo changedcombo = (FarPoint.Win.FpCombo)e.EditingControl;
            if (newlist.Count == 0)
            {
                list = changedcombo.List;
            }
            else
            {
                list = newlist;
            }

            list.Remove(selecteditem);
            if (fpSpread1.Sheets[0].Cells[e.Row, e.Column].Value != null)
                list.Add(fpSpread1.Sheets[0].Cells[e.Row, e.Column].Value);
            newlist = list;
            if (newlist.Count != 0)
            {
                changedcombo.List = newlist;
                changedcombo.SelectedIndex = list.IndexOf(fpSpread1.Sheets[0].Cells[e.Row, e.Column].Value);
            }
        }

        void fpSpread1_ComboSelChange(object sender, FarPoint.Win.Spread.EditorNotifyEventArgs e)
        {
            FarPoint.Win.FpCombo combo = (FarPoint.Win.FpCombo)e.EditingControl;
            selecteditem = (string)combo.SelectedItem;
        }
    }
    
}
